Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3297)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3298)
@@ -1464,46 +2002,46 @@
 !> prognostic_equations.
 !------------------------------------------------------------------------------!
- SUBROUTINE chem_prognostic_equations_ij ( cs_scalar_p, cs_scalar, tcs_scalar_m, pr_init_cs,  &
-                            i, j, i_omp_start, tn, ilsp, flux_s_cs, diss_s_cs, &
-                            flux_l_cs, diss_l_cs )
-    USE pegrid         
-    USE advec_ws,        ONLY:  advec_s_ws 
-    USE advec_s_pw_mod,  ONLY:  advec_s_pw
-    USE advec_s_up_mod,  ONLY:  advec_s_up
-    USE diffusion_s_mod, ONLY:  diffusion_s
-    USE indices,         ONLY:  wall_flags_0
-    USE surface_mod,     ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,    &
-                                surf_usm_v
-
-
-    IMPLICIT NONE
-
-    REAL(wp), DIMENSION(:,:,:), POINTER   :: cs_scalar_p, cs_scalar, tcs_scalar_m
-
-    INTEGER(iwp),INTENT(IN) :: i, j, i_omp_start, tn, ilsp
-    REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1)         :: flux_s_cs   !<
-    REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1)         :: diss_s_cs   !<
-    REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) :: flux_l_cs   !<
-    REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) :: diss_l_cs   !<
-    REAL(wp), DIMENSION(0:nz+1)                                 :: pr_init_cs  !<
+    SUBROUTINE chem_prognostic_equations_ij ( cs_scalar_p, cs_scalar, tcs_scalar_m, pr_init_cs,    &
+                               i, j, i_omp_start, tn, ilsp, flux_s_cs, diss_s_cs,                  &
+                               flux_l_cs, diss_l_cs )
+       USE pegrid         
+       USE advec_ws,        ONLY:  advec_s_ws 
+       USE advec_s_pw_mod,  ONLY:  advec_s_pw
+       USE advec_s_up_mod,  ONLY:  advec_s_up
+       USE diffusion_s_mod, ONLY:  diffusion_s
+       USE indices,         ONLY:  wall_flags_0
+       USE surface_mod,     ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,     &
+                                   surf_usm_v
+
+
+       IMPLICIT NONE
+
+       REAL(wp), DIMENSION(:,:,:), POINTER   :: cs_scalar_p, cs_scalar, tcs_scalar_m
+
+       INTEGER(iwp),INTENT(IN) :: i, j, i_omp_start, tn, ilsp
+       REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1)         :: flux_s_cs   !<
+       REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1)         :: diss_s_cs   !<
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) :: flux_l_cs   !<
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) :: diss_l_cs   !<
+       REAL(wp), DIMENSION(0:nz+1)                                 :: pr_init_cs  !<
 
 !-- local variables
 
-    INTEGER :: k
-    !
-    !--    Tendency-terms for chem spcs.
-    tend(:,j,i) = 0.0_wp
+       INTEGER :: k
+!
+!--    Tendency-terms for chem spcs.
+       tend(:,j,i) = 0.0_wp
 !    
 !-- Advection terms
-    IF ( timestep_scheme(1:5) == 'runge' )  THEN
-       IF ( ws_scheme_sca )  THEN
-          CALL advec_s_ws( i, j, cs_scalar, 'kc', flux_s_cs, diss_s_cs,                &
-             flux_l_cs, diss_l_cs, i_omp_start, tn )
+       IF ( timestep_scheme(1:5) == 'runge' )  THEN
+          IF ( ws_scheme_sca )  THEN
+             CALL advec_s_ws( i, j, cs_scalar, 'kc', flux_s_cs, diss_s_cs,                &
+                flux_l_cs, diss_l_cs, i_omp_start, tn )
+          ELSE
+             CALL advec_s_pw( i, j, cs_scalar )
+          ENDIF
        ELSE
-          CALL advec_s_pw( i, j, cs_scalar )
+            CALL advec_s_up( i, j, cs_scalar )
        ENDIF
-    ELSE
-         CALL advec_s_up( i, j, cs_scalar )
-    ENDIF
 
 !
@@ -1511,369 +2049,242 @@
 !-- Diffusion terms (the last three arguments are zero)
 
-      CALL diffusion_s( i, j, cs_scalar,                                                 &
-                        surf_def_h(0)%cssws(ilsp,:), surf_def_h(1)%cssws(ilsp,:),        &
-                        surf_def_h(2)%cssws(ilsp,:),                                     &
-                        surf_lsm_h%cssws(ilsp,:), surf_usm_h%cssws(ilsp,:),              &
-                        surf_def_v(0)%cssws(ilsp,:), surf_def_v(1)%cssws(ilsp,:),        &
-                        surf_def_v(2)%cssws(ilsp,:), surf_def_v(3)%cssws(ilsp,:),        &
-                        surf_lsm_v(0)%cssws(ilsp,:), surf_lsm_v(1)%cssws(ilsp,:),        &
-                        surf_lsm_v(2)%cssws(ilsp,:), surf_lsm_v(3)%cssws(ilsp,:),        &
-                        surf_usm_v(0)%cssws(ilsp,:), surf_usm_v(1)%cssws(ilsp,:),        &
-                        surf_usm_v(2)%cssws(ilsp,:), surf_usm_v(3)%cssws(ilsp,:) )
- 
+         CALL diffusion_s( i, j, cs_scalar,                                                 &
+                           surf_def_h(0)%cssws(ilsp,:), surf_def_h(1)%cssws(ilsp,:),        &
+                           surf_def_h(2)%cssws(ilsp,:),                                     &
+                           surf_lsm_h%cssws(ilsp,:), surf_usm_h%cssws(ilsp,:),              &
+                           surf_def_v(0)%cssws(ilsp,:), surf_def_v(1)%cssws(ilsp,:),        &
+                           surf_def_v(2)%cssws(ilsp,:), surf_def_v(3)%cssws(ilsp,:),        &
+                           surf_lsm_v(0)%cssws(ilsp,:), surf_lsm_v(1)%cssws(ilsp,:),        &
+                           surf_lsm_v(2)%cssws(ilsp,:), surf_lsm_v(3)%cssws(ilsp,:),        &
+                           surf_usm_v(0)%cssws(ilsp,:), surf_usm_v(1)%cssws(ilsp,:),        &
+                           surf_usm_v(2)%cssws(ilsp,:), surf_usm_v(3)%cssws(ilsp,:) )
+    
 !    
 !-- Prognostic equation for chem spcs
-    DO k = nzb+1, nzt
-       cs_scalar_p(k,j,i) = cs_scalar(k,j,i) + ( dt_3d  *                       &
-                                               ( tsc(2) * tend(k,j,i) +         &
-                                                 tsc(3) * tcs_scalar_m(k,j,i) ) & 
-                                               - tsc(5) * rdf_sc(k)             &
-                                                        * ( cs_scalar(k,j,i) - pr_init_cs(k) )    &   
-                                               )                                                  &
-                                                        * MERGE( 1.0_wp, 0.0_wp,                  &      
-                                                                BTEST( wall_flags_0(k,j,i), 0 )   &             
-                                                                 )       
-
-       IF ( cs_scalar_p(k,j,i) < 0.0_wp )  cs_scalar_p(k,j,i) = 0.1_wp * cs_scalar(k,j,i)    !FKS6
-    ENDDO
+       DO k = nzb+1, nzt
+          cs_scalar_p(k,j,i) = cs_scalar(k,j,i) + ( dt_3d  *                       &
+                                                  ( tsc(2) * tend(k,j,i) +         &
+                                                    tsc(3) * tcs_scalar_m(k,j,i) ) & 
+                                                  - tsc(5) * rdf_sc(k)             &
+                                                           * ( cs_scalar(k,j,i) - pr_init_cs(k) )    &   
+                                                  )                                                  &
+                                                           * MERGE( 1.0_wp, 0.0_wp,                  &      
+                                                                   BTEST( wall_flags_0(k,j,i), 0 )   &             
+                                                                    )       
+
+          IF ( cs_scalar_p(k,j,i) < 0.0_wp )  cs_scalar_p(k,j,i) = 0.1_wp * cs_scalar(k,j,i)    !FKS6
+       ENDDO
 
 !
 !-- Calculate tendencies for the next Runge-Kutta step
-    IF ( timestep_scheme(1:5) == 'runge' )  THEN
-       IF ( intermediate_timestep_count == 1 )  THEN
-          DO  k = nzb+1, nzt
-             tcs_scalar_m(k,j,i) = tend(k,j,i)
-          ENDDO
-       ELSEIF ( intermediate_timestep_count < &
-          intermediate_timestep_count_max )  THEN
-          DO  k = nzb+1, nzt
-             tcs_scalar_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
-                5.3125_wp * tcs_scalar_m(k,j,i)
-          ENDDO
+       IF ( timestep_scheme(1:5) == 'runge' )  THEN
+          IF ( intermediate_timestep_count == 1 )  THEN
+             DO  k = nzb+1, nzt
+                tcs_scalar_m(k,j,i) = tend(k,j,i)
+             ENDDO
+          ELSEIF ( intermediate_timestep_count < &
+             intermediate_timestep_count_max )  THEN
+             DO  k = nzb+1, nzt
+                tcs_scalar_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
+                   5.3125_wp * tcs_scalar_m(k,j,i)
+             ENDDO
+          ENDIF
        ENDIF
-    ENDIF
-
- END SUBROUTINE chem_prognostic_equations_ij
-
-
+
+    END SUBROUTINE chem_prognostic_equations_ij
+
+!
 !------------------------------------------------------------------------------!
 !
 ! Description:
 ! ------------
-!> Subroutine calculating prognostic equations for chemical species 
-!> (vector-optimized).
-!> Routine is called separately for each chemical species over a loop from
-!> prognostic_equations.
-!------------------------------------------------------------------------------!
- SUBROUTINE chem_prognostic_equations ( cs_scalar_p, cs_scalar, tcs_scalar_m,  &
-                                        pr_init_cs, ilsp )
-
-    USE advec_s_pw_mod,                                                        &
-        ONLY:  advec_s_pw
-
-    USE advec_s_up_mod,                                                        &
-        ONLY:  advec_s_up
-
-    USE advec_ws,                                                              &
-        ONLY:  advec_s_ws 
-
-    USE diffusion_s_mod,                                                       &
-        ONLY:  diffusion_s
-
-    USE indices,                                                               &
-        ONLY:  nxl, nxr, nyn, nys, wall_flags_0
-
-    USE pegrid
-
-    USE surface_mod,                                                           &
-        ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,     &
-               surf_usm_v
+!> Subroutine to read restart data of chemical species
+!------------------------------------------------------------------------------!
+
+    SUBROUTINE chem_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,         &
+                               nxr_on_file, nynf, nync, nyn_on_file, nysf, nysc,  &
+                               nys_on_file, tmp_3d, found )    
+                                        
+       USE control_parameters
+               
+       USE indices
+       
+       USE pegrid
+
+       IMPLICIT NONE 
+
+       CHARACTER (LEN=20) :: spc_name_av !<   
+          
+       INTEGER(iwp) ::  i, lsp          !< 
+       INTEGER(iwp) ::  k               !< 
+       INTEGER(iwp) ::  nxlc            !< 
+       INTEGER(iwp) ::  nxlf            !< 
+       INTEGER(iwp) ::  nxl_on_file     !<   
+       INTEGER(iwp) ::  nxrc            !< 
+       INTEGER(iwp) ::  nxrf            !< 
+       INTEGER(iwp) ::  nxr_on_file     !<   
+       INTEGER(iwp) ::  nync            !< 
+       INTEGER(iwp) ::  nynf            !< 
+       INTEGER(iwp) ::  nyn_on_file     !<   
+       INTEGER(iwp) ::  nysc            !< 
+       INTEGER(iwp) ::  nysf            !< 
+       INTEGER(iwp) ::  nys_on_file     !<   
+       
+       LOGICAL, INTENT(OUT)  :: found 
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !< 3D array to temp store data
+
+
+       found = .FALSE.  
+
+
+          IF ( ALLOCATED(chem_species) )  THEN
+
+             DO  lsp = 1, nspec
+
+                 !< for time-averaged chemical conc.
+                spc_name_av  =  TRIM(chem_species(lsp)%name)//'_av'
+
+                IF (restart_string(1:length) == TRIM(chem_species(lsp)%name) )    &
+                THEN
+                   !< read data into tmp_3d
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d  
+                   !< fill ..%conc in the restart run    
+                   chem_species(lsp)%conc(:,nysc-nbgp:nync+nbgp,                  &
+                                          nxlc-nbgp:nxrc+nbgp) =                  & 
+                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                   found = .TRUE.
+                ELSEIF (restart_string(1:length) == spc_name_av )  THEN
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   chem_species(lsp)%conc_av(:,nysc-nbgp:nync+nbgp,               &
+                                             nxlc-nbgp:nxrc+nbgp) =               &
+                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                   found = .TRUE.
+                ENDIF
+
+             ENDDO
+
+          ENDIF
+
+
+    END SUBROUTINE chem_rrd_local
+!
+!-------------------------------------------------------------------------------!
+!> Description:
+!> Calculation of horizontally averaged profiles
+!> This routine is called for every statistic region (sr) defined by the user,
+!> but at least for the region "total domain" (sr=0).
+!> quantities.
+!------------------------------------------------------------------------------!
+    SUBROUTINE chem_statistics( mode, sr, tn )
+
+
+       USE arrays_3d
+       USE indices
+       USE kinds
+       USE pegrid
+       USE statistics
+
+    USE user
 
     IMPLICIT NONE
 
-    INTEGER ::  i   !< running index
-    INTEGER ::  j   !< running index
-    INTEGER ::  k   !< running index
-
-    INTEGER(iwp),INTENT(IN) ::  ilsp          !<
-
-    REAL(wp), DIMENSION(0:nz+1) ::  pr_init_cs   !<
-
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  cs_scalar      !<
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  cs_scalar_p    !<
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  tcs_scalar_m   !<
-
-
-!
-!-- Tendency terms for chemical species
-    tend = 0.0_wp
-!    
-!-- Advection terms
-    IF ( timestep_scheme(1:5) == 'runge' )  THEN
-       IF ( ws_scheme_sca )  THEN
-          CALL advec_s_ws( cs_scalar, 'kc' )
-       ELSE
-          CALL advec_s_pw( cs_scalar )
-       ENDIF
-    ELSE
-         CALL advec_s_up( cs_scalar )
-    ENDIF
-!
-!-- Diffusion terms  (the last three arguments are zero)
-    CALL diffusion_s( cs_scalar,                                               &
-                      surf_def_h(0)%cssws(ilsp,:),                             &
-                      surf_def_h(1)%cssws(ilsp,:),                             &
-                      surf_def_h(2)%cssws(ilsp,:),                             &
-                      surf_lsm_h%cssws(ilsp,:),                                &
-                      surf_usm_h%cssws(ilsp,:),                                &
-                      surf_def_v(0)%cssws(ilsp,:),                             &
-                      surf_def_v(1)%cssws(ilsp,:),                             &
-                      surf_def_v(2)%cssws(ilsp,:),                             &
-                      surf_def_v(3)%cssws(ilsp,:),                             &
-                      surf_lsm_v(0)%cssws(ilsp,:),                             &
-                      surf_lsm_v(1)%cssws(ilsp,:),                             &
-                      surf_lsm_v(2)%cssws(ilsp,:),                             &
-                      surf_lsm_v(3)%cssws(ilsp,:),                             &
-                      surf_usm_v(0)%cssws(ilsp,:),                             &
-                      surf_usm_v(1)%cssws(ilsp,:),                             &
-                      surf_usm_v(2)%cssws(ilsp,:),                             &
-                      surf_usm_v(3)%cssws(ilsp,:) )
-!    
-!-- Prognostic equation for chemical species
-    DO  i = nxl, nxr
-       DO  j = nys, nyn    
-          DO  k = nzb+1, nzt
-             cs_scalar_p(k,j,i) =   cs_scalar(k,j,i)                           &
-                                  + ( dt_3d  *                                 &
-                                      (   tsc(2) * tend(k,j,i)                 &
-                                        + tsc(3) * tcs_scalar_m(k,j,i)         &
-                                      )                                        & 
-                                    - tsc(5) * rdf_sc(k)                       &
-                                             * ( cs_scalar(k,j,i) - pr_init_cs(k) )    &   
-                                    )                                          &
-                                    * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )       
-
-             IF ( cs_scalar_p(k,j,i) < 0.0_wp )  cs_scalar_p(k,j,i) = 0.1_wp * cs_scalar(k,j,i)
+    CHARACTER (LEN=*) ::  mode   !< 
+
+    INTEGER(iwp) :: i    !< running index on x-axis
+    INTEGER(iwp) :: j    !< running index on y-axis
+    INTEGER(iwp) :: k    !< vertical index counter
+    INTEGER(iwp) :: sr   !< statistical region
+    INTEGER(iwp) :: tn   !< thread number 
+    INTEGER(iwp) :: n    !<
+    INTEGER(iwp) :: m    !<
+    INTEGER(iwp) :: lpr  !< running index chem spcs
+!    REAL(wp),                                                                                      &
+!    DIMENSION(dots_num_palm+1:dots_max) ::                                                         &
+!          ts_value_l   !< 
+
+    IF ( mode == 'profiles' )  THEN
+!
+!--    Sample on how to calculate horizontally averaged profiles of user-
+!--    defined quantities. Each quantity is identified by the index
+!--    "pr_palm+#" where "#" is an integer starting from 1. These
+!--    user-profile-numbers must also be assigned to the respective strings
+!--    given by data_output_pr_cs in routine user_check_data_output_pr.
+!--    hom(:,:,:,:) =  dim-1 = vertical level, dim-2= 1: met-species,2:zu/zw, dim-3 = quantity( e.g.
+!                       w*pt*), dim-4 = statistical region.
+
+       !$OMP DO
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+              DO  k = nzb, nzt+1
+                DO lpr = 1, cs_pr_count
+
+                   sums_l(k,pr_palm+lpr,tn) = sums_l(k,pr_palm+lpr,tn) +    &
+                                                 chem_species(cs_pr_index(lpr))%conc(k,j,i) *       &
+                                                 rmask(j,i,sr)  *                                   &
+                                                 MERGE( 1.0_wp, 0.0_wp,                             &
+                                                 BTEST( wall_flags_0(k,j,i), 22 ) )
+                ENDDO                                                                          
+             ENDDO
           ENDDO
        ENDDO
-    ENDDO
-!
-!-- Calculate tendencies for the next Runge-Kutta step
-    IF ( timestep_scheme(1:5) == 'runge' )  THEN
-       IF ( intermediate_timestep_count == 1 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn   
-                DO  k = nzb+1, nzt
-                   tcs_scalar_m(k,j,i) = tend(k,j,i)
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSEIF ( intermediate_timestep_count < &
-          intermediate_timestep_count_max )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-                   tcs_scalar_m(k,j,i) = - 9.5625_wp * tend(k,j,i)             &
-                                         + 5.3125_wp * tcs_scalar_m(k,j,i)
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
+    ELSEIF ( mode == 'time_series' )  THEN
+       CALL location_message( 'Time series not calculated for chemistry', .TRUE. )
     ENDIF
 
- END SUBROUTINE chem_prognostic_equations
-
-
+    END SUBROUTINE chem_statistics
+!
 !------------------------------------------------------------------------------!
 !
 ! Description:
 ! ------------
-!> Subroutine defining header output for chemistry model
-!------------------------------------------------------------------------------!
- SUBROUTINE chem_header ( io )
-       
-    IMPLICIT NONE 
- 
-       INTEGER(iwp), INTENT(IN) ::  io            !< Unit of the output file
-
-!      print*,'the header subroutine is still not operational'     
-!!
-!!--    Write chemistry model header
-!       WRITE( io, 3 )
-!
-!       IF ( radiation_scheme == "constant" )  THEN 
-!          WRITE( io, 4 ) net_radiation
-!       ELSEIF ( radiation_scheme == "clear-sky" )  THEN 
-!          WRITE( io, 5 )
-!       ELSEIF ( radiation_scheme == "rrtmg" )  THEN 
-!          WRITE( io, 6 )
-!          IF ( .NOT. lw_radiation )  WRITE( io, 10 ) 
-!          IF ( .NOT. sw_radiation )  WRITE( io, 11 ) 
-!       ENDIF 
-!
-!       IF ( albedo_type == 0 )  THEN 
-!          WRITE( io, 7 ) albedo
-!       ELSE
-!          WRITE( io, 8 ) TRIM( albedo_type_name(albedo_type) )
-!       ENDIF
-!       IF ( constant_albedo )  THEN 
-!          WRITE( io, 9 )
-!       ENDIF
-!     
-!       IF ( radiation .AND. radiation_scheme /= 'constant' )  THEN 
-!          WRITE ( io, 1 )  lambda
-!          WRITE ( io, 2 )  day_init, time_utc_init
-!       ENDIF
-!
-!       WRITE( io, 12 ) dt_radiation
-! 
-! 1 FORMAT ('    Geograph. longitude            :   lambda = ',F4.1,' degr')
-! 2 FORMAT ('    Day of the year at model start :   day_init = ',I3   &
-!            /'    UTC time at model start        :   time_utc_init = ',F7.1' s')
-! 3 FORMAT (//' Radiation model information:'/                                  &
-!              ' ----------------------------'/)
-! 4 FORMAT ('    --> Using constant net radiation: net_radiation = ', F6.2,        &
-!           // 'W/m**2')
-! 5 FORMAT ('    --> Simple radiation scheme for clear sky is used (no clouds,',   &
-!                   ' default)')
-! 6 FORMAT ('    --> RRTMG scheme is used')
-! 7 FORMAT (/'    User-specific surface albedo: albedo =', F6.3)
-! 8 FORMAT (/'    Albedo is set for land surface type: ', A)
-! 9 FORMAT (/'    --> Albedo is fixed during the run')
-!10 FORMAT (/'    --> Longwave radiation is disabled')
-!11 FORMAT (/'    --> Shortwave radiation is disabled.')
-!12 FORMAT  ('    Timestep: dt_radiation = ', F6.2, '  s')
-!
-!
- END SUBROUTINE chem_header
-
-!------------------------------------------------------------------------------
+!> Subroutine for swapping of timelevels for chemical species
+!> called out from subroutine swap_timelevel
+!------------------------------------------------------------------------------!
+
+    SUBROUTINE chem_swap_timelevel (level)
+
+          IMPLICIT   none
+
+          INTEGER,INTENT(IN)        :: level
+!--       local variables
+          INTEGER                   :: lsp
+
+
+          IF ( level == 0 ) THEN
+             DO lsp=1, nvar                                       
+                chem_species(lsp)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => spec_conc_1(:,:,:,lsp)
+                chem_species(lsp)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  => spec_conc_2(:,:,:,lsp)
+             ENDDO
+          ELSE
+             DO lsp=1, nvar                                        
+                chem_species(lsp)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => spec_conc_2(:,:,:,lsp)
+                chem_species(lsp)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  => spec_conc_1(:,:,:,lsp)
+             ENDDO
+          ENDIF
+
+       RETURN
+    END SUBROUTINE chem_swap_timelevel
+!
+!------------------------------------------------------------------------------!
+!
 ! Description:
 ! ------------
-!> Subroutine reading restart data for chemistry model input parameters
-!  (FK: To make restarts work, I had to comment this routine. We actually
-!       don't need it, since the namelist parameters are always read in,
-!       also in case of a restart run)
-!------------------------------------------------------------------------------
-!  SUBROUTINE chem_rrd_global
-!
-!    USE chem_modules
-!
-!    USE control_parameters,                                                   &
-!        ONLY: length, message_string, restart_string
-! 
-!     
-!     IMPLICIT NONE
-!     
-!     
-!     
-!     DO
-! 
-!        SELECT CASE ( restart_string(1:length) )
-!        
-!           CASE ( 'bc_cs_b' )
-!              READ ( 13 )  bc_cs_b
-!
-!           CASE DEFAULT
-!
-!              EXIT
-!            
-!        END SELECT
-!        
-!!
-!!--     Read next string and its length
-!        READ ( 13 )  length
-!        READ ( 13 )  restart_string(1:length)
-!        
-!     ENDDO
-!     
-!  END SUBROUTINE chem_rrd_global
-
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine writing restart data for chemistry model input parameters
-!  (FK: To make restarts work, I had to comment this routine. We actually
-!       don't need it, since the namelist parameters are always read in,
-!       also in case of a restart run)
-!------------------------------------------------------------------------------!
-!  SUBROUTINE chem_wrd_global
-! 
-!     USE chem_modules
-!     
-!     USE kinds
-! 
-! 
-!     IMPLICIT NONE
-! 
-!     INTEGER(iwp) ::  lsp  !< running index for chem spcs
-! 
-! !
-! !-- Writing out input parameters that are not part of chemistry_parameters 
-! !-- namelist (namelist parameters are anyway read in again in case of restart)
-!     DO lsp = 1, nvar
-!        CALL wrd_write_string( 'conc_pr_init_'//chem_species(lsp)%name )
-!        WRITE ( 14 )  chem_species(lsp)%conc_pr_init
-!     ENDDO
-! 
-! 
-!  END SUBROUTINE chem_wrd_global
-
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine for emission
-!------------------------------------------------------------------------------!
- SUBROUTINE chem_emissions
-
-    USE chem_modules
-    
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  street_type_f
-    
-    USE surface_mod,                                                           &
-        ONLY:  surf_lsm_h
-
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i    !< running index for grid in x-direction
-    INTEGER(iwp) ::  j    !< running index for grid in y-direction
-    INTEGER(iwp) ::  m    !< running index for horizontal surfaces
-    INTEGER(iwp) ::  lsp  !< running index for chem spcs
-
-!
-!-- Comment??? (todo)
-    IF ( street_type_f%from_file )  THEN
-!
-!--    Streets are lsm surfaces, hence, no usm surface treatment required
-       DO  m = 1, surf_lsm_h%ns
-          i = surf_lsm_h%i(m)
-          j = surf_lsm_h%j(m)
-          
-          IF ( street_type_f%var(j,i) >= main_street_id  .AND.                 &
-               street_type_f%var(j,i) < max_street_id )  THEN
-             DO  lsp = 1, nvar
-                surf_lsm_h%cssws(lsp,m) = emiss_factor_main * surface_csflux(lsp)
-             ENDDO
-          ELSEIF ( street_type_f%var(j,i) >= side_street_id  .AND.             &
-                   street_type_f%var(j,i) < main_street_id )  THEN
-             DO  lsp = 1, nvar
-                surf_lsm_h%cssws(lsp,m) = emiss_factor_side * surface_csflux(lsp)
-             ENDDO
-          ELSE
-             surf_lsm_h%cssws(:,m) = 0.0_wp
-          ENDIF
+!> Subroutine to write restart data for chemistry model
+!------------------------------------------------------------------------------!
+    SUBROUTINE chem_wrd_local
+
+       IMPLICIT NONE 
+
+       INTEGER(iwp) ::  lsp !< 
+
+       DO  lsp = 1, nspec
+          CALL wrd_write_string( TRIM( chem_species(lsp)%name ))
+          WRITE ( 14 )  chem_species(lsp)%conc
+          CALL wrd_write_string( TRIM( chem_species(lsp)%name )//'_av' )
+          WRITE ( 14 )  chem_species(lsp)%conc_av
        ENDDO
-       
-    ENDIF
-
- END SUBROUTINE chem_emissions
-
-
+
+    END SUBROUTINE chem_wrd_local
  END MODULE chemistry_model_mod
 
Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 3297)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 3298)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! minor formatting (kanani)
+! chem_data_output_2d subroutine added (basit)
+! 
+! 3294 2018-10-01 02:37:10Z raasch
 ! changes concerning modularization of ocean option
 ! 
@@ -252,6 +256,9 @@
         ONLY:  bulk_cloud_model, bcm_data_output_2d
 
+    USE chemistry_model_mod,                                                   &
+        ONLY:  chem_data_output_2d
+
     USE control_parameters,                                                    &
-        ONLY:  data_output_2d_on_each_pe, data_output_xy,                      &
+        ONLY:  air_chemistry, data_output_2d_on_each_pe, data_output_xy,       &
                data_output_xz, data_output_yz, do2d,                           &
                do2d_xy_last_time, do2d_xy_time_count,                          &
@@ -265,5 +272,5 @@
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point 
-
+        
     USE gust_mod,                                                              &
         ONLY:  gust_data_output_2d, gust_module_enabled
@@ -1326,4 +1333,8 @@
                 ENDIF
 
+                IF ( .NOT. found  .AND.  air_chemistry )  THEN
+                   CALL chem_data_output_2d( av, do2d(av,if), found, grid, mode, &
+                                             local_pf, two_d, nzb_do, nzt_do, fill_value )
+                ENDIF
 !
 !--             User defined quantities
Index: palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- palm/trunk/SOURCE/data_output_mask.f90	(revision 3297)
+++ palm/trunk/SOURCE/data_output_mask.f90	(revision 3298)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Minor formatting (kanani)
+! Call for chem_data_output_mask added (basit)
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -133,5 +137,5 @@
         ONLY:  e, nc, nr, p, pt, q, qc, ql, ql_c, ql_v, qr, rho_ocean, s, sa,  &
                tend, u, v, vpt, w, d_exner
-    
+
     USE averaging,                                                             &
         ONLY:  e_av, lpt_av, nc_av, nr_av, p_av, pc_av, pr_av, pt_av, q_av,    &
@@ -141,7 +145,10 @@
     USE basic_constants_and_equations_mod,                                     &
         ONLY:  lv_d_cp
-    
+
+    USE chemistry_model_mod,                                                   &
+        ONLY:  chem_data_output_mask
+
     USE control_parameters,                                                    &
-        ONLY:  domask, domask_no, domask_time_count, mask_i,                   &
+        ONLY:  air_chemistry, domask, domask_no, domask_time_count, mask_i,    &
                mask_j, mask_k, mask_size, mask_size_l, mask_start_l,           &
                max_masks, message_string, mid, nz_do3d, simulated_time
@@ -151,5 +158,5 @@
     USE indices,                                                               &
         ONLY:  nbgp, nxl, nxr, nyn, nys, nzb
-        
+
     USE kinds
 
@@ -524,5 +531,4 @@
 
           CASE DEFAULT
-
 !
 !--          Radiation quantity
@@ -532,4 +538,8 @@
              ENDIF
 
+             IF ( air_chemistry )  THEN
+                CALL chem_data_output_mask(av, domask(mid,av,ivar), found,     &
+                                           local_pf )
+             ENDIF
 !
 !--          User defined quantity
